# Version Management

This document describes how version management works in the pyspark-analyzer project.

## Current Setup

## Automated Version Bumping

Use the GitHub Actions workflow:

1. Go to Actions → Version Bump
2. Click "Run workflow"
3. Select bump type (patch/minor/major)
4. The workflow will create a PR with the version changes

## Version Numbering

We follow [Semantic Versioning](https://semver.org/):
- **MAJOR**: Incompatible API changes
- **MINOR**: New functionality (backwards compatible)
- **PATCH**: Bug fixes (backwards compatible)

## Configuration

The `.bumpversion.cfg` file controls:
- Current version tracking
- Files to update
- Commit and tag behavior
- Tag naming format (v{version})

## Troubleshooting

### Version Mismatch
If versions get out of sync:
1. Check current git tag: `git describe --tags`
2. Update `.bumpversion.cfg` to match
3. Manually sync other files if needed

### Failed Release
If a release fails:
1. Check GitHub Actions logs
2. Verify PyPI token is valid
3. Ensure version wasn't already published
